/* cc-includes.h */

#include <exec/exec.h>
#include <exec/execbase.h>
#include <exec/lists.h>
#include <exec/memory.h>
#include <exec/nodes.h>
#include <exec/types.h>
#include <graphics/gfx.h>
#include <graphics/gfxmacros.h>
#include <graphics/display.h>
#include <graphics/displayinfo.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <intuition/screens.h>
#include <libraries/diskfont.h>
#include <libraries/gadtools.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/* die entsprechenden Matheroutinen includen */

#ifdef _M68881
	#include <m68881.h>
#endif

/* Prototypes fr Libraryfunctions */

#include <proto/diskfont.h>
#include <proto/exec.h>
#include <proto/gadtools.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/utility.h>

#define __CXM33 __UCXM33				/* fr Utillitie.library */
#define __CXD33 __UCXD33
#define __CXM22 __UCXM22
#define __CXD22 __UCXD22

#define MakeID(a,b,c,d)	( (LONG)(a)<<24L | (LONG)(b)<<16L | (c)<<8 | (d) )

#define PREF_FORM		MakeID('F','O','R','M')
#define PREF_PREF		MakeID('P','R','E','F')
#define PREF_ICAC		MakeID('I','C','A','C')
#define PREF_DCAC		MakeID('D','C','A','C')
#define PREF_CBCK		MakeID('C','B','C','K')

typedef struct							/* Prefs V3.1 */
{
	ULONG	id;								/* FORM,ICAC,DCAC,CBCK */
	ULONG	len;							/* 4+(8+2)+(8+2)+(8+2)=34 */
} Prefs_Hdr;

typedef struct								/* ICAC : 2 Bytes */
{
	UBYTE	cache,burst;
} Data_ICache;

typedef struct								/* DCAC : 2 Bytes */
{
	UBYTE	cache,burst;
} Data_DCache;

typedef struct								/* CBCK : 2 Bytes */
{
	UBYTE	cpybck,pad;
} Data_CpyBck;
